var express = require('express');
var app = express();
var serveStatic = require('serve-static');
var oracledb = require('oracledb');

app.use('/', serveStatic(__dirname + '/public'));
app.use('/vendor', serveStatic(__dirname + '/bower_components'));

app.get('/api/employees', getEmployees);

function getEmployees(req, res, next) {
    oracledb.getConnection({
        user: 'hr',
        password: 'oracle',
        connectString: 'localhost:1523/orcl'
    }, function(err, connection) {
        if (err) return next(err);

        connection.execute(
            'SELECT employee_id, ' +
            '   first_name, ' +
            '   last_name, ' +
            '   phone_number, ' +
            '   hire_date ' +
            'FROM employees',
            {},//no binds
            {
                outFormat: oracledb.OBJECT
            },
            function(err, results) {
                if (err) {
                    return connection.release(function() {
                        next(err);
                    });
                }

                connection.release(function(err) {
                    if (err) return next(err);

                    res.send(results.rows);
                });
            }
        );
    });
}

app.listen('3000', function() {
    console.log('Server running at http://localhost:3000/');
});